<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/hashed_array.php';
require_once 'lib/tv/abstract_tv.php';
require_once 'lib/tv/default_epg_item.php';
require_once 'lib/tv/epg_iterator.php';
require_once 'lib/user_input_handler_registry.php';

require_once 'ktv_channel.php';

///////////////////////////////////////////////////////////////////////////

class KtvTv extends AbstractTv implements UserInputHandler
{
    private $session;
	public function get_handler_id() { return "tv"; }
    ///////////////////////////////////////////////////////////////////////

    public function __construct($session)
    {
        $this->session = $session;
		UserInputHandlerRegistry::get_instance()->register_handler($this);
        parent::__construct(
            AbstractTv::MODE_CHANNELS_1_TO_N,
            true,
            false);
    }

    public function get_fav_icon_url()
    {
        return dirname(__FILE__)."/icons/fav.png";
    }

    ///////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////

    public function load_channels(&$plugin_cookies)
    {
		hd_print(__METHOD__);
		
        $this->session->check_logged_in();
		$buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
        
		$show_cat_test=0;
		$show_cat = isset($plugin_cookies->show_cat) ? $plugin_cookies->show_cat : '';
		
		if($show_cat !== '')
			$show_cat = json_decode($show_cat);
		else
		{
			$show_cat_test = 1;
			$show_cat = Array();
		}
		$delete_cat = isset($plugin_cookies->delete_cat) ? $plugin_cookies->delete_cat : '';
		//hd_print(print_r(json_decode($delete_cat)));
		
		if($delete_cat !== '')
			$delete_cat = json_decode($delete_cat);
		else
			$delete_cat =Array();
		
        $this->channels = new HashedArray();
        $this->groups = new HashedArray();

        $this->groups->put(
            new FavoritesGroup(
                $this,
                '__favorites',
                'Избранное',
                dirname(__FILE__)."/icons/Beliebte.png"));

        $this->groups->put(
            new AllChannelsGroup(
                $this,
                'Все каналы',
                dirname(__FILE__)."/icons/Alle.png"));
				
				

        $put_groups=Array();
       
	   
		$m3u_lines =
            file(
                $this->session->get_channel_list(),
                FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
	
		
        for ($i = 0; $i < count($m3u_lines); ++$i)
        {	
            if (preg_match('/EXTINF:/i', $m3u_lines[$i]))
			{
				//hd_print("____________".$m3u_lines[$i]);
				$pars = explode('group-title="', $m3u_lines[$i]);
				if(count($pars) > 1)
				$group_name = strstr($pars[1], '"', true);
				else
					$group_name = "Прочие";
				
				if (!in_array($group_name, $put_groups) && !in_array($group_name, $delete_cat))
					array_push($put_groups, $group_name);
				//hd_print(count($put_groups));
				if (!in_array($group_name, $show_cat))
					array_push($show_cat, $group_name);
				
            if ($i + 1 >= count($m3u_lines))
                break;
			}
        }
		//foreach($show_cat as $cat)
			//	hd_print(base64_encode($cat).".png     --:$cat");
		if($show_cat_test === 1 && count($show_cat > 15 )){
			$i=0;
			$put_groups=Array();
			$delete_cat=Array();
			$show_cat2=Array();
			foreach($show_cat as $cat){
				
					if($i < 15){
						array_push($put_groups, $cat);
						array_push($show_cat2, $cat);
					}
					else
						array_push($delete_cat, $cat);
				$i++;
			}
			$show_cat = $show_cat2;
			$plugin_cookies->delete_cat = json_encode($delete_cat);
		}
			
		$plugin_cookies->show_cat = json_encode($show_cat);
		
		$pars = explode('x-tvg-url="', $m3u_lines[0]);
		$epg_url = str_replace(".xml", ".zip", strstr($pars[1], '"', true));
		
		
		$epg_file_name = explode("/", $epg_url);
		$this->epg_file_name = '/tmp/'.$epg_file_name[3];
		hd_print($this->epg_file_name);
		
		if(!file_exists($this->epg_file_name)){
		system('wget "'.$epg_url.'" -P /tmp');
		system('unzip '.$this->epg_file_name.' -d /tmp');
		}
		
		if(file_exists($this->epg_file_name)){
			$stat = stat($this->epg_file_name);
			$file_date = date("Y-m-d", $stat['mtime']);
				if(date("Y-m-d") !== $file_date){
					system('rm '.$this->epg_file_name);
          system('rm '.str_replace(".zip", ".xml", $this->epg_file_name));
					system('wget "'.$epg_url.'" -P /tmp');
						system('unzip '.$this->epg_file_name.' -d /tmp');
				}
		}

		$i=1;
		foreach ($put_groups as $g)
        {
			//hd_print(dirname(__FILE__)."/icons/".str_replace("/", "", base64_encode($g)).".png");
			hd_print($g."----".str_replace("/", "", base64_encode($g)));
            $this->groups->put(
                new DefaultGroup(
                    strval($i),
                    strval($g),
                    dirname(__FILE__)."/icons/".str_replace("/", "", base64_encode($g)).".png"));//dirname(__FILE__)."/icons/folder.png"));//Group icon
        $i++;
		}
		
		for ($i = 0; $i < count($m3u_lines); ++$i)
			{
			
            if (preg_match('/EXTINF:/i', $m3u_lines[$i]))
			{
				$pars = explode(',', $m3u_lines[$i]);
				$caption = $pars[1];
				
				$pars = explode('tvg-id="', $m3u_lines[$i]);
				if(count($pars) > 1)
				$id = strstr($pars[1], '"', true);
				else
					$id = "0";
				
				$pars = explode('tvg-logo="', $m3u_lines[$i]);
				if(count($pars) > 1)
				$channel_icon = strstr($pars[1], '"', true);
				else
				$channel_icon = 0;
				
				$pars = explode('tvg-id="', $m3u_lines[$i]);
				if(count($pars) > 1)
				$epg = strstr($pars[1], '"', true);
				else
				$epg = 0;
				
				$pars = explode('arc-time="', $m3u_lines[$i]);
				if(count($pars) > 1)
				$archive = 1;//strstr($pars[1], '"', true);
				else
				$archive = 0;
				
				
				$pars = explode('group-title="', $m3u_lines[$i]);
				if(count($pars) > 1)
				$group_name = strstr($pars[1], '"', true);
				else
				$group_name = "Прочие";
				

				
				$media_url = $m3u_lines[$i + 1];
				
				$protect_code = 0;
				if($group_name == 'EROTIK')
					$protect_code = 1;
				
				if ($i + 1 >= count($m3u_lines))
					break;			
			if(!in_array($group_name, $delete_cat)){
					$channel =
					new KtvChannel(
						$i.base64_encode($caption).$epg,//$i,
						strval($caption),
						strval($channel_icon),
						strval($media_url),
						-1,
						3,
						4,
						$protect_code,
						$epg,
						$archive);

					$this->channels->put($channel);
			
					foreach ($this->groups as $g){
				
					$tv_category_id = strval($g->get_id());
				
					$group = $this->groups->get($tv_category_id);

					if($g->get_title() == $group_name){
					$channel->add_group($group);
					$group->add_channel($channel);	}
					}
				}
			}
			}
 $m3u_lines="";
    }
	//////////////////////////////NEW////////////////////////////////////
	private function get_ktv_dialog_action($n)
    {
        $params = array('n' => $n);
        return UserInputHandlerRegistry::create_action($this,
            'dialog', $params);
    }
	private function get_ktv_reset_controls_action($n)
    {
        $params = array('n' => $n);
        return UserInputHandlerRegistry::create_action($this,
            'reset_controls', $params);
    }
	private function get_set_default_behaviour_action()
    {
        return ActionFactory::change_behaviour(
            array(
                GUI_EVENT_KEY_DUNE => $this->get_ktv_dialog_action(0),
            ));
    }
	private function get_sample_dialog_defs($n)
    {
        $defs = array();
		ControlFactory::add_label($defs, null,
            'Сделали:');
			ControlFactory::add_label($defs, null,
            'Сайт:');
        ControlFactory::add_label($defs, null,
            'Подождите '.(10 - $n).' секунд или нажмите RETURN для закрытия...');
        return $defs;
    }

    private function get_sample_dialog_action($n)
    {
        return ActionFactory::show_dialog("Плагин для Дюны",
            $this->get_sample_dialog_defs($n),
            false, 0,
            array(
                'actions' => array(
                    GUI_EVENT_TIMER =>
                        $this->get_ktv_reset_controls_action($n + 1),
                    GUI_EVENT_KEY_RETURN => ActionFactory::close_dialog_and_run(
                        $this->get_set_default_behaviour_action()),
                ),
                'timer' => ActionFactory::timer(900),
                'dialog_params' => array('frame_style' => DIALOG_FRAME_STYLE_GLASS)));
    }
	
	public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('TV entry handler: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");

        
        if ($user_input->control_id == 'dialog')
        {
            return $this->get_sample_dialog_action($user_input->n);
        }

        if ($user_input->control_id == 'reset_controls')
        {
            $close_action = ActionFactory::close_dialog_and_run(
                $this->get_set_default_behaviour_action());

            if ($user_input->n >= 9)
                $timer_action = $close_action;
            else
            {
                $timer_action = 
                    $this->get_ktv_reset_controls_action($user_input->n + 1);
            }

            return ActionFactory::reset_controls(
                $this->get_sample_dialog_defs($user_input->n),
                ActionFactory::change_behaviour(
                    array(
                        GUI_EVENT_TIMER => $timer_action,
                        GUI_EVENT_KEY_RETURN => $close_action,
                    ),
                    ActionFactory::timer(900)
                )
            );
        }

        return null;
    }
	/////////////////////////////////////////////////////////////////
    public function get_tv_info(MediaURL $media_url, &$plugin_cookies)
    {
        $this->session->ensure_logged_in($plugin_cookies);
        $info = parent::get_tv_info($media_url, &$plugin_cookies);

        $info[PluginTvInfo::actions] = array(

            GUI_EVENT_KEY_DUNE => $this->get_ktv_dialog_action(0),

        );
        return $info;
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_tv_stream_url($playback_url, &$plugin_cookies)
    {
        return $playback_url;
    }

    public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies)
    {
		$buf_time = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
        $this->ensure_channels_loaded($plugin_cookies);

        $media_url = str_replace("http://", "http://ts://", $this->get_channel($channel_id)->get_streaming_url());
		
		if($archive_ts > 0)
			$media_url .= "?utc=$archive_ts&lutc=".time();
		
		$pass_sex = isset($plugin_cookies->pass_sex) ? $plugin_cookies->pass_sex : '1234';
		$protected = $this->get_channel($channel_id)->is_protected();
		if ($protected) 
        {
       	   if ($protect_code !== $pass_sex)  $media_url=''; 
        }
		
		hd_print("OPEN MEDIA-URL: $media_url");
        return $media_url;
    }

    ///////////////////////////////////////////////////////////////////////
	public function get_tv_for_rec($channel_id, &$plugin_cookies)
    {
		return true;
	}
    ///////////////////////////////////////////////////////////////////////

    public function get_day_epg_iterator($channel_id, $day_start_ts, &$plugin_cookies)
    {
		hd_print(__METHOD__);
		
		$epg_shift = isset($plugin_cookies->epg_shift) ? 
			$plugin_cookies->epg_shift : '0';
       
		    $channels = $this->get_channels();
            $c = $channels->get($channel_id);
           
            $epg_id = $c->get_epg();
			$epg_date = date("Y-m-d", $day_start_ts);
			$date = date("Ymd", $day_start_ts);
				$replace =array (
					'&#196;' => 'Ä',
					'&#228;' => 'ä',
					'&#214;' => 'Ö',
					'&#220;' => 'Ü',
					'&#223;' => 'ß',
					'&#246;' => 'ö',
					'&#252;'=>'ü',
					'&#39;'=>"'",
					'&quot;'=>'"');
					$handle = fopen(str_replace(".zip", ".xml", $this->epg_file_name), "rb");

			if (FALSE === $handle)
				exit("Konnte Stream von URL nicht öffnen");
			$contents = '';
			$test="";
			$i=0;
			$stop=0;
		while (!feof($handle)) {
			$contents .= fread($handle, 105000);
				if(!preg_match('/channel=\"'.$epg_id.'/i', $contents))
					$contents="";
				else{
					$test .= $contents;
					if($stop === 0)
						$stop=$i;
					if($i - $stop === 1)
						break;
					}
				$i++;
			}
		fclose($handle);

		$epg_array=array();
		//hd_print($test);
		$pars=explode('<programme start="', $test);
		if(count($pars) < 2)
			hd_print("NOT!");
		unset($pars[0]);

		foreach($pars as $parsing){
			if(preg_match('/'.$date.'/i', $parsing) && preg_match('/channel=\"'.$epg_id.'/i', $parsing)){
				//hd_print($parsing);
				$time=strstr($parsing, '"', true);
			
				//hd_print("time: $time");
				
				$re=explode(">", $parsing);
				$title=strstr($re[2], '<', true);
				//hd_print($title);
				if(preg_match('/'.$date.'/i', $time) && !isset($epg_array[$time]))
				$epg_array[$time]=$title;
				
			
				//else
					//break;
			}
		}
		ksort($epg_array);
		$epg_result=Array();

		foreach($epg_array as $key=>$res){
			//hd_print("KEY: $key");
					$epg_result[] =
					new DefaultEpgItem(
						str_replace(array_keys($replace), $replace, $res),
						'',//strval($description),
						intval(strtotime($key) + $epg_shift),
						intval(-1));
		}

		return
            new EpgIterator(
                $epg_result,
                $day_start_ts,
                $day_start_ts + 100400); 
			///////////////////////////////////////////////////////////
    }

    public function get_archive(MediaURL $media_url)
    {
        return true;
    }

    public function folder_entered(MediaURL $media_url, &$plugin_cookies)
    {
        if (!isset($media_url->screen_id) ||
            $media_url->screen_id === TvGroupListScreen::ID)
        {
            $this->session->logout();
        }

        $this->session->ensure_logged_in($plugin_cookies);
    }

    
	// Hook for adding special group items.
		
	public function add_special_groups(&$items)
    {
        array_unshift($items,
            array
            (
                PluginRegularFolderItem::media_url =>
                    MediaURL::encode(
                        array
                        (
                            'screen_id' => KtvVodRootScreen::ID,
							'name' => 'VODDE',
                        )),
                PluginRegularFolderItem::caption => 'DE VOD',
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path =>
                        "plugin_file://icons/vod/vodde.png"
                )
			)
			// ,
			// array
            // (
            //     PluginRegularFolderItem::media_url =>
            //         MediaURL::encode(
            //             array
            //             (
            //                 'screen_id' => KtvVodRootScreen::ID,
			// 				'name' => 'VODRU',
			// 				'content' => $this->session->get_kinozone_list(),
			// 				'category' => 'yes'
            //             )),
            //     PluginRegularFolderItem::caption => 'Кинозал',
            //     PluginRegularFolderItem::view_item_params => array
            //     (
            //         ViewItemParams::icon_path =>
            //             "plugin_file://icons/vod/kino.png"
            //     )
            // )
			);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
