<?php
///////////////////////////////////////////////////////////////////////////

class KtvTvGroupListScreen extends TvGroupListScreen
{
    private $session;

    public function __construct($session, $tv, $folder_views)
    {
        parent::__construct($tv, $folder_views);

        $this->session = $session;
    }

    /*public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
		hd_print(__METHOD__);
        $this->session->logout();
        $this->session->ensure_logged_in($plugin_cookies);
        $this->tv->ensure_channels_loaded($plugin_cookies);

        $new_items[] = array
        (
            PluginRegularFolderItem::media_url =>
                MediaURL::encode(
                    array
                    (
                        'screen_id' => KtvVodRootScreen::ID,
                    )),
            PluginRegularFolderItem::caption => 'Видеотека',
            PluginRegularFolderItem::view_item_params => array
            (
                ViewItemParams::icon_path => "plugin_file://icons/folder.png"
            )
        );

        $parent_items = 
            parent::get_all_folder_items($media_url, $plugin_cookies);

        return array_merge($new_items, $parent_items);
    }*/
	public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
        $this->tv->folder_entered($media_url, $plugin_cookies);

        $this->tv->ensure_channels_loaded($plugin_cookies);

        $items = array();

        foreach ($this->tv->get_groups() as $group)
        {
            $media_url = $group->is_favorite_channels() ?
                TvFavoritesScreen::get_media_url_str() :
                TvChannelListScreen::get_media_url_str($group->get_id());

            $items[] = array
            (
                PluginRegularFolderItem::media_url => $media_url,
                PluginRegularFolderItem::caption => $group->get_title(),
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => $group->get_icon_url(),
                    ViewItemParams::item_detailed_icon_path => $group->get_icon_url()
                )
            );
        }

        $this->tv->add_special_groups($items);

        return $items;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
