<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/vod/abstract_vod.php';
require_once 'lib/vod/movie.php';

///////////////////////////////////////////////////////////////////////////

class KtvVod extends AbstractVod
{
    private $session;

    public function __construct($session)
    {
        $this->session = $session;

        parent::__construct(true, true, false);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_vod_info(MediaURL $media_url, &$plugin_cookies)
    {
		hd_print(__METHOD__);
        $this->session->ensure_logged_in($plugin_cookies);

        return parent::get_vod_info($media_url, &$plugin_cookies);
    }

    public function try_load_movie($movie_id, &$plugin_cookies)
    {
		hd_print(__METHOD__);
        
		$season_show = isset($plugin_cookies->season_show) ? $plugin_cookies->season_show : 'no';
		$season_url = isset($plugin_cookies->season_url) ? $plugin_cookies->season_url : '0';
		
		$movie = new Movie($movie_id);
		$test = explode("&&&", $movie_id);
		hd_print($test[1]);
		if(preg_match('/http/i', $test[1])){
				$url=$test[1];
				if($season_show === 'yes')
					$url=$season_url;
				$xml=HD::http_get_document($url);
				$pars=simplexml_load_string($xml, 'SimpleXMLElement', LIBXML_NOCDATA);
				
					$movie->set_data(
					$test[2],//$doc->film->name,
					"",//$doc->film->name_orig,
					"",//$doc->film->description,
					0,//$poster_url,
					0,//$doc->film->lenght,
					0,//$doc->film->year,
					0,//$doc->film->director,
					0,//$doc->film->scenario,
					0,//$doc->film->actors,
					0,//$doc->film->genre_str,
					0,//$doc->film->rate_imdb,
					0,//$doc->film->rate_kinopoisk,
					0,//$doc->film->rate_mpaa,
					0,//$doc->film->country,
					0);//$doc->film->budget);

					foreach($pars->Children() as $c){
						if(isset($c->stream_url)){
					$movie->add_series_data(
						$movie_id,
					strip_tags($c->title),//$file->title,
						$c->stream_url,
						false);}


				}
		}
		else{
		$m3u_lines = file("/tmp/kingvod.m3u", FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);

		    for ($i = 0; $i < count($m3u_lines); ++$i)
			{
				if (preg_match('/EXTINF:/i', $m3u_lines[$i]))
				{
				$pars = explode(',', $m3u_lines[$i]);
				$caption = $pars[1];
				
            	$pars = explode('tvg-logo="', $m3u_lines[$i]);
				if(count($pars) > 1)
				$channel_icon = strstr($pars[1], '"', true);
				else
				$channel_icon = 0;
				
				$playback_url = $m3u_lines[$i + 1];
				
				
				if($caption == $test[1]){
					
					$poster_url = "";//'http://' . KTV::$SERVER . $doc->film->poster;

					$movie->set_data(
					$caption,//$doc->film->name,
					"",//$doc->film->name_orig,
					"",//$doc->film->description,
					0,//$poster_url,
					0,//$doc->film->lenght,
					0,//$doc->film->year,
					0,//$doc->film->director,
					0,//$doc->film->scenario,
					0,//$doc->film->actors,
					0,//$doc->film->genre_str,
					0,//$doc->film->rate_imdb,
					0,//$doc->film->rate_kinopoisk,
					0,//$doc->film->rate_mpaa,
					0,//$doc->film->country,
					0);//$doc->film->budget);

					$movie->add_series_data(
						$movie_id,
						$caption,//$file->title,
						$playback_url,
						false);
					}
				
				if ($i + 1 >= count($m3u_lines))
					break;
				}
			}
		}

        
        $this->set_cached_movie($movie);
    }

	///////////////////
	public function get_vod_pl($series_id, &$plugin_cookies)
	{
		hd_print(__METHOD__);
	$pl_url = sprintf(KTV_VOD_GET_URL_URL, KTV::$SERVER,
                    $this->session->get_sid_name(),
					$this->session->get_sid(),
                    $series_id);
	$tmp = str_replace('http://mp4://', 'http://', $pl_url);
	$f = file_get_contents($tmp);
	$file_rec = urldecode(stripslashes($f));
	#hd_print("FFFFF------->$file_rec");
	return $file_rec;
	}
	///////////////
	
    public function get_vod_stream_url($playback_url, &$plugin_cookies)
    {
		hd_print(__METHOD__);
		//$playback_url = str_replace("https", "http", $playback_url);
		//$mov = $this->session->api_get_stream_url($playback_url);
		hd_print("MOVIE--->>>>$playback_url");
		 
  return $playback_url;

		//return str_replace("http://", "http://mp4://", $playback_url);
    }

    public function get_buffering_ms()
    {
        //$this->session->check_logged_in();

        //$settings = $this->session->get_settings();
        return "1000";//$settings->http_caching->value;
    }

    ///////////////////////////////////////////////////////////////////////
    // Favorites.

   protected function load_favorites(&$plugin_cookies)
    {
        $fav_movie_ids = $this->get_fav_movie_ids_from_cookies($plugin_cookies);

        foreach ($fav_movie_ids as $movie_id)
        {
            if ($this->has_cached_short_movie($movie_id))
                continue;

            $this->ensure_movie_loaded($movie_id, $plugin_cookies);
        }

        $this->set_fav_movie_ids($fav_movie_ids);

        hd_print('The ' . count($fav_movie_ids) . ' favorite movies loaded.');
    }

    protected function do_save_favorite_movies(&$fav_movie_ids, &$plugin_cookies)
    {
        $this->set_fav_movie_ids_to_cookies($plugin_cookies, $fav_movie_ids);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_fav_movie_ids_from_cookies(&$plugin_cookies)
    {
        if (!isset($plugin_cookies->{'favorite_movies'}))
            return array();

        $arr = preg_split('/,/', $plugin_cookies->{'favorite_movies'});

        $ids = array();
        foreach ($arr as $id)
        {
            if (preg_match('/\S/', $id))
                $ids[] = $id;
        }
        return $ids;
    }

    public function set_fav_movie_ids_to_cookies(&$plugin_cookies, &$ids)
    {
        $plugin_cookies->{'favorite_movies'} = join(',', $ids);
    }


    ///////////////////////////////////////////////////////////////////////
    // Genres.

    protected function load_genres(&$plugin_cookies)
    {
        $doc = $this->session->api_vod_genres();

        $genres = array();
        foreach ($doc->genres as $genre)
            $genres[$genre->id] = $genre->name;

        return $genres;
    }

    public function get_genre_icon_url($genre_id)
    {
        return $this->session->get_icon('mov_genre_default.png');
    }

    public function get_genre_media_url_str($genre_id)
    {
        return KtvVodListScreen::get_media_url_str('genres', $genre_id);
    }

    ///////////////////////////////////////////////////////////////////////
    // Search.

    public function get_search_media_url_str($pattern)
    {
        return KtvVodListScreen::get_media_url_str('search', $pattern);
    }

    ///////////////////////////////////////////////////////////////////////
    // Folder views.

    public function get_vod_genres_folder_views()
    {
        $mov_genre_default_icon_url =
            $this->session->get_icon('mov_genre_default.png');

        return array(
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 3,
                    ViewParams::num_rows => 10,
#                    ViewParams::content_box_padding_bottom => 110,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_padding_top => 0,
                    ViewItemParams::item_padding_bottom => 0,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::item_caption_width => 365,
                    ViewItemParams::icon_dx => 65,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array
                (
                    ViewItemParams::icon_path => $mov_genre_default_icon_url,
                ),
            ));
    }

    public function get_vod_list_folder_views()
        {
         return array(
		    

            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::paint_details => true,
                    ViewParams::zoom_detailed_icon => true,
                    ViewParams::num_cols => 6,
                    ViewParams::num_rows => 2,
                    //ViewParams::paint_details => false,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                    ViewParams::sandwich_width => 125,
                    ViewParams::sandwich_height => 200,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.25,
                    ViewItemParams::icon_sel_scale_factor => 1.5,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
        );
    }
    public function get_archive(MediaURL $media_url)
    {
        return true;
    }

    public function folder_entered(MediaURL $media_url, &$plugin_cookies)
    {
        $this->session->ensure_logged_in($plugin_cookies);
    }
}

///////////////////////////////////////////////////////////////////////////
?>
