<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/vod/vod_list_screen.php';

class KtvVodListScreen extends VodListScreen
{
    private $session;
    public static function get_media_url_str($cat_id,$text = null)
    {
		//hd_print(__METHOD__);
        $arr['screen_id'] = self::ID;
        $arr['category_id'] = $cat_id;
		if($cat_id === 'search')
			$arr['pattern'] = $text;
        else if ($cat_id === 'genres')
            $arr['genre_id'] = $text;
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    public function __construct($session, Vod $vod)
    {
        parent::__construct($vod);
		$this->session = $session;
		$this->vod = $vod;
    }
    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
		hd_print(__METHOD__);
        $actions = array();

        //if ($this->vod->is_movie_page_supported())
          //  $actions[GUI_EVENT_KEY_ENTER] = ActionFactory::open_folder();
        //else
            $actions[GUI_EVENT_KEY_ENTER] = ActionFactory::vod_play();

        /*if ($this->vod->is_favorites_supported())
        {
            $add_favorite_action =
                UserInputHandlerRegistry::create_action(
                    $this, 'add_favorite');
            $add_favorite_action['caption'] = 'В Избранное';


            $actions[GUI_EVENT_KEY_D_BLUE] = $add_favorite_action;
        }*/

        return $actions;
    }
    ///////////////////////////////////////////////////////////////////////
    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
		
        hd_print('Vod favorites: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");
		
		if ($user_input->control_id == 'add_favorite')
        {
            if (!isset($user_input->selected_media_url))
                return null;

            $media_url = MediaURL::decode($user_input->selected_media_url);
            $movie_id = $media_url->movie_id;

            $is_favorite = $this->vod->is_favorite_movie_id($movie_id);
            if ($is_favorite)
            {
                return ActionFactory::show_title_dialog(
                    'Фильм уже в избранном');
            }
            else
            {
                $this->vod->add_favorite_movie($movie_id, $plugin_cookies);

                return ActionFactory::show_title_dialog(
                    'Фильм был добавлен в избранное');
            }
        }

        return null;
    }

    protected function get_short_movie_range(MediaURL $media_url, $from_ndx,
        &$add_list, &$plugin_cookies)
    {
		//hd_print(__METHOD__);
		//$this->session->check_login($plugin_cookies);
		
		 //hd_print(print_r($media_url));
		
		$add_list += 100;
		if(preg_match('/http/i', $media_url->category_id)){
			hd_print($media_url->category_id);
				$xml=HD::http_get_document($media_url->category_id);
				$pars=simplexml_load_string($xml, 'SimpleXMLElement', LIBXML_NOCDATA);	
				$movies = Array();
				
				$i=1;
				foreach($pars->Children() as $c){
				if(isset($c->playlist_url)){
				$movies[] = new ShortMovie(
                $i."&&&".$c->playlist_url."&&&".$c->title, $c->title, $c->logo_30x30);
				}
				$i++;
				}
				
		 return new ShortMovieRange(0, count($movies), $movies);
		}
		else{
		if($media_url->category_id === 'ALL')
		{
			//hd_print("ALL");
			$cat="ALL";
		}
		elseif(substr($media_url->category_id, 0, 4) === 'CATE')
		{
				//hd_print("CATE");
				$pars = explode("CATE", $media_url->category_id);
				$cat = $pars[1];
			}
		
	
       
		$m3u_lines = file("/tmp/kingvod.m3u", FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
	
		
        $movies = array();
		if($cat === "ALL"){
        for ($i = 0; $i < count($m3u_lines); ++$i)
        {
				if (preg_match('/EXTINF:/i', $m3u_lines[$i]))
				{
				$pars = explode(',', $m3u_lines[$i]);
				$caption = $pars[1];
				
            	$pars = explode('tvg-logo="', $m3u_lines[$i]);
				if(count($pars) > 1)
				$channel_icon = strstr($pars[1], '"', true);
				else
				$channel_icon = 0;
				
				$url = $m3u_lines[$i + 1];
				
				$movies[] = new ShortMovie(
                $i."&&&".$caption, $caption, $channel_icon);

				if ($i + 1 >= count($m3u_lines))
					break;
				}
			}
		}
		else
		{
			for ($i = 0; $i < count($m3u_lines); ++$i)
			{
				if (preg_match('/EXTINF:/i', $m3u_lines[$i]))
				{
				$pars = explode(',', $m3u_lines[$i]);
				$caption = $pars[1];
				
            	$pars = explode('tvg-logo="', $m3u_lines[$i]);
				if(count($pars) > 1)
				$channel_icon = strstr($pars[1], '"', true);
				else
				$channel_icon = 0;
				
				$pars = explode('group-title="', $m3u_lines[$i]);
				if(count($pars) > 1)
				$group_name = strstr($pars[1], '"', true);
				else
					$group_name = "Прочие";
				
				$url = $m3u_lines[$i + 1];
				
				
				if($group_name === $cat){
				$movies[] = new ShortMovie(
                $i."&&&".$caption, $caption, $channel_icon);
				}
				if ($i + 1 >= count($m3u_lines))
					break;
				}
			}
		}

        return new ShortMovieRange(0, count($movies), $movies);
	}
    }
	
	public function get_folder_range(MediaURL $media_url, $from_ndx, &$plugin_cookies)
    {
        //hd_print("VodListScreen---->>> staring ||get_folder_range()>>>>>>");
          hd_print(__METHOD__);     
        $movie_range = $this->get_short_movie_range(
            $media_url, $from_ndx, $this->vod->add_list, $plugin_cookies);
        $total = intval($movie_range->total);
		//hd_print($total."----------------------");
        if ($total <= 0)
            return HD::create_regular_folder_range(array());

        
        $total_num = 0;    
        $items = array();
        foreach ($movie_range->short_movies as $movie)
        {
            ++$total_num;
            
            //self::add_movie($movie, $items, $plugin_cookies);
            $items[] = array
            (
                PluginRegularFolderItem::media_url =>
                    VodMovieScreen::get_media_url_str($movie->id),
                PluginRegularFolderItem::caption => $movie->name,
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path => $movie->poster_url,
					ViewItemParams::icon_width => 120,
                    ViewItemParams::icon_height => 179,
                )
            );

            $this->vod->set_cached_short_movie(
                new ShortMovie($movie->id, $movie->name, $movie->poster_url));
        }
                
        /*if ($movie_range->from_ndx == 0)
            ++$total_num;*/
        
        //////////////////////// Подгрузка списка кинозала ///////////////////////
        return  HD::create_regular_folder_range
                (
                    $items,
                    $movie_range->from_ndx > 0 ? $movie_range->from_ndx - 1 : 0,
                    $movie_range->from_ndx+$total_num,
                    count($movie_range->short_movies) > 0
                );
        
    }
	
	public function get_folder_view(MediaURL $media_url, &$plugin_cookies)
    {
       //hd_print("ExUaVodListScreen---->>> staring ||get_folder_view()>>>>>>");
        
       $this->vod->add_list = 100;

       return parent::get_folder_view($media_url, $plugin_cookies);
    }
	
    public function get_archive(MediaURL $media_url)
    { 
        return $this->session->get_archive();
    }
}

///////////////////////////////////////////////////////////////////////////
?>
