<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/abstract_preloaded_regular_screen.php';

class KtvVodRootScreen extends AbstractPreloadedRegularScreen
implements UserInputHandler
{
    const ID = 'vod_root';

    private $session;
	    public static function get_media_url_str($cat_id,$text = null)
    {
		//hd_print(__METHOD__);
        $arr['screen_id'] = self::ID;
        $arr['category_id'] = $cat_id;
		if($cat_id === 'search')
			$arr['pattern'] = $text;
        else if ($cat_id === 'genres')
            $arr['genre_id'] = $text;
        return MediaURL::encode($arr);
    }

    public function __construct($session, $folder_views)
    {
        parent::__construct(self::ID, $folder_views);

        $this->session = $session;
		
        UserInputHandlerRegistry::get_instance()->
            register_handler($this);
    }

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
		    $search_check = isset($plugin_cookies->search_check) ? 
			$plugin_cookies->search_check : 'no';
			$plugin_cookies->search_check = 'no';
			
			$actions = array();

            $actions[GUI_EVENT_KEY_ENTER] = ActionFactory::open_folder();
        
            $add_search =
                UserInputHandlerRegistry::create_action(
                    $this, 'add_search');
            $add_search['caption'] = 'Search';
	
			if($media_url->name !== 'VODDE')
            $actions[GUI_EVENT_KEY_D_BLUE] = $add_search;
           
        

        return $actions;
    }
    public function get_handler_id()
    { return self::ID; }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('Vod favorites: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");

        if ($user_input->control_id == 'search')
        {
            if (!isset($user_input->selected_media_url))
                return null;
			
			$category=json_decode($user_input->parent_media_url);
			
			
			$search_text = $this->session->get_serach_url().$user_input->user_name;
			
			if($category->category === 'no')
			$search_text = $this->session->get_serach_serials_url().$user_input->user_name;
			
			return ActionFactory::close_dialog_and_run(ActionFactory::open_folder(KtvVodListScreen::get_media_url_str($search_text), "Search"));
			
        }
        
		else if ($user_input->control_id == 'add_search')
        {
            if (!isset($user_input->selected_media_url))
                return null;

           

		$media_url = MediaURL::decode($user_input->selected_media_url);
	
			 
			$add_params = NULL;
              return ActionFactory::show_dialog(
            'Search',
            $this->do_get_edit_subscription_defs(
                $plugin_cookies, $this, $add_params),
            true);
        }

        return null;
    }
	private function do_get_edit_subscription_defs(
        &$plugin_cookies, $handler, $add_params)
    {
        $defs = array();

        ControlFactory::add_text_field($defs,
            $handler, $add_params,
            'user_name', '',
            "", false, false, false, false, 750);


        ControlFactory::add_vgap($defs, 100);

        ControlFactory::add_button($defs,
            $handler, $add_params,
            'search', null, 'Send', 300);

        ControlFactory::add_vgap($defs, -3);

        ControlFactory::add_close_dialog_button($defs,
            'Close', 300);

        return $defs;
    }
    public function get_all_folder_items(MediaURL $media_url, &$plugin_cookies)
    {
		//hd_print(print_r($media_url));
		hd_print("VODDE");
		if($media_url->name === 'VODDE'){
			$doc=$this->session->api_vod_list($plugin_cookies->user_name, $plugin_cookies->password, &$plugin_cookies);
		
		$put_groups=Array();
		
		$parsing = explode("#EXTINF:", $doc);
		foreach($parsing as $b){
				
				$pars = explode('group-title="', $b);
				if(count($pars) > 1){
				$group_name = strstr($pars[1], '"', true);
				
				if (!in_array($group_name, $put_groups))
				array_push($put_groups, $group_name);}	
			
		}
		
		$defs = array(
            array(
                KtvVodListScreen::get_media_url_str('ALL'),
                'Все', "plugin_file://icons/Alle.png")
				);
				foreach($put_groups as $gr){
                array_push($defs, array(KtvVodListScreen::get_media_url_str("CATE".$gr), strval($gr), "plugin_file://icons/Alle.png"));					
				}
            
        

        $items = array();

        foreach ($defs as $def)
        {
			hd_print("plugin_file://icons/vod/".base64_encode($def[1]).".png");
			hd_print($def[0]);
            $items[] = array
            (
                PluginRegularFolderItem::media_url => $def[0],
                PluginRegularFolderItem::caption => $def[1],
                PluginRegularFolderItem::view_item_params => array
                (
                    ViewItemParams::icon_path =>
                        "plugin_file://icons/vod/".base64_encode($def[1]).".png"
                )
            );
        }

        return $items;
	}
	///////////////////////////////////////////////////////////////////////////////
			if($media_url->name === 'VODRU'){
		hd_print(".....".$media_url->category);
		$xml=HD::http_get_document($media_url->content);
		$pars=simplexml_load_string($xml, 'SimpleXMLElement', LIBXML_NOCDATA);

		
		$items = array();
		
	
		foreach($pars->Children() as $c){
			
				if(isset($c->playlist_url)){
				if(strval($c->title) !== 'Сериалы' && strval($c->title) !== 'Поиск'){
					$items[] = array
					(
					PluginRegularFolderItem::media_url => KtvVodListScreen::get_media_url_str(strval($c->playlist_url)),
					PluginRegularFolderItem::caption => strval($c->title),
					PluginRegularFolderItem::view_item_params => array
					(
                    ViewItemParams::icon_path => strval($c->logo_30x30)
					));
				}
				else if(strval($c->title) === 'Сериалы'){
					$items[] = array
					(
					PluginRegularFolderItem::media_url => MediaURL::encode(
                        array
                        (
                            'screen_id' => KtvVodRootScreen::ID,
							'name' => 'VODRU',
							'content' => strval($c->playlist_url),
							'category' => 'no'
                        )),
					PluginRegularFolderItem::caption => 'Serials',
					PluginRegularFolderItem::view_item_params => array
					(
                    ViewItemParams::icon_path =>
                        "plugin_file://icons/vod/kino.png"
					),//KtvVodListScreen::get_media_url_str(strval($c->playlist_url)),
					PluginRegularFolderItem::caption => strval($c->title),
					PluginRegularFolderItem::view_item_params => array
					(
                    ViewItemParams::icon_path => strval($c->logo_30x30)
					));
				}
				
			}			
		}
		
        return $items;
	}
		///////////////////////////////////////////////////////////////////////////////
		
    }
}

///////////////////////////////////////////////////////////////////////////
?>
